<template>
  <Navbar />
  <body
    class="flex flex-col items-center justify-center w-screen bg-base-100 text-gray-800 p-10"
    style="height: calc(100vh - 64px)"
  >
    <div class="w-full flex flex-grow justify-center">
      <div
        class="flex flex-col mr-8 w-2/7 bg-white shadow-xl rounded-lg overflow-hidden"
      >
        <div class="flex bg-primary w-full items-center p-8 justify-between">
          <p class="text-white text-2xl font-semibold">Chats</p>

          <div v-if="rolUsuario == 'DOCENTE'">
            <ModalDocente :usuario="$data.usuario"></ModalDocente>
          </div>
          <div v-if="rolUsuario == 'APODERADO'">
            <ModalApoderado :usuario="$data.usuario"></ModalApoderado>
          </div>
        </div>
        <div class="flex flex-col flex-grow w-96 h-0 overflow-auto scrollbar">
          <div
            v-for="(chat, index) in conversaciones"
            :key="chat.msgId"
            :item="mensaje"
            :index="index"
          >
            <div
              v-if="chat.emisor.usuId == usuario.usuId"
              class="flex w-full cursor-pointer hover:bg-neutral items-center p-2 border-b-2 border-neutral"
              @click="abrirChat(chat.receptor.usuId)"
            >
              <img
                src="../../assets/user.png"
                alt=""
                class="flex-shrink-0 rounded-full h-10 w-10"
              />
              <div class="text-black p-3 w-11/12">
                <p class="font-semibold">
                  {{ chat.receptor.nombre }} {{ chat.receptor.apellidoPaterno }}
                </p>
                <div class="flex">
                  <p class="text-sm text-[#616161] mr-1">Tú:</p>
                  <p class="text-sm">{{ chat.cuerpo }}</p>
                </div>
              </div>
            </div>
            <div
              v-if="chat.emisor.usuId != usuario.usuId"
              class="flex w-full cursor-pointer hover:bg-neutral items-center p-2 border-b-2 border-neutral"
              @click="abrirChat(chat.emisor.usuId)"
            >
              <img
                src="../../assets/user.png"
                alt=""
                class="flex-shrink-0 rounded-full h-10 w-10"
              />
              <div class="text-black p-3 w-11/12">
                <p class="font-semibold">
                  {{ chat.emisor.nombre }} {{ chat.emisor.apellidoPaterno }}
                </p>
                <div class="flex">
                  <p class="text-sm text-[#616161] mr-1">
                    {{ chat.emisor.nombre }}:
                  </p>
                  <p class="text-sm">{{ chat.cuerpo }}</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div
        name="showme"
        class="flex flex-col min-w-2/3 w-2/3 bg-white shadow-xl rounded-lg overflow-hidden"
      >
        <div
          v-if="hayChatAbierto"
          class="flex bg-white w-full justify-center items-center p-8 border-b-2 border-primary"
        >
          <img
            src="../../assets/user.png"
            alt=""
            class="flex-shrink-0 rounded-full h-12 w-12 mr-2"
          />
          <p class="text-primary text-2xl font-semibold">
            {{ nombreReceptor }}
          </p>
        </div>
        <div
          v-if="!hayChatAbierto"
          class="flex bg-white w-full justify-center items-center p-8 border-b-2 border-primary"
        >
          <p class="text-primary text-2xl font-semibold">
            Selecciona un chat primero
          </p>
        </div>
        <div
          class="ventana-chat flex flex-col flex-grow h-0 p-4 overflow-auto scrollbar"
          id="messageBody"
        >
          <div
            v-for="(mensaje, index) in chatActual"
            :key="mensaje.msgId"
            :item="mensaje"
            :index="index"
          >
            <div
              v-if="mensaje.emisor.usuId != this.usuario.usuId"
              class="flex w-full mt-2 space-x-3 max-w-xs"
            >
              <img
                src="../../assets/user.png"
                alt=""
                class="flex-shrink-0 rounded-full h-10 w-10 mr-2"
              />
              <div>
                <div
                  class="border-secondary border-2 text-black p-3 rounded-lg"
                >
                  <p class="text-sm">{{ mensaje.cuerpo }}</p>
                </div>
                <span class="text-xs text-gray-500 leading-none">{{
                  formatearFecha(mensaje.fechaMsg)
                }}</span>
              </div>
            </div>
            <div
              v-if="mensaje.emisor.usuId == this.usuario.usuId"
              class="flex w-full mt-2 space-x-3 max-w-xs ml-auto justify-end"
            >
              <div>
                <div
                  class="border-secondary border-2 text-black p-3 rounded-lg"
                >
                  <p class="text-sm">{{ mensaje.cuerpo }}</p>
                </div>
                <span class="text-xs text-gray-500 leading-none">{{
                  formatearFecha(mensaje.fechaMsg)
                }}</span>
              </div>
              <img
                src="../../assets/user.png"
                alt=""
                class="flex-shrink-0 rounded-full h-10 w-10 mr-2"
              />
            </div>
          </div>
        </div>

        <div v-if="hayChatAbierto">
          <div
            v-if="rolUsuario != 'ALUMNO'"
            class="flex items-center bg-neutral p-4"
          >
            <input
              class="input input-bordered input-md bg-white w-11/12 mr-4 rounded-full px-3 text-sm"
              type="text"
              placeholder="Escribe un mensaje aqui..."
              v-model="text"
            />

            <button
              @click="enviarMensaje(receptor)"
              class="btn btn-md rounded-full btn-secondary text-white font bold"
            >
              enviar
            </button>
          </div>
        </div>
      </div>
    </div>
  </body>
  <Footer></Footer>
</template>

<script>
import axios from "axios";
import moment from "moment";
import ModalApoderado from "../../components/MENSAJERIA/modalApoderado.vue";
import ModalDocente from "../../components/MENSAJERIA/modalDocente.vue";
import Navbar from "../../components/Navbar.vue";
import Footer from "../../components/Footer.vue";

export default {
  data() {
    return {
      usuario: null,
      chatActual: [],
      conversaciones: [],
      receptor: null,
      nombreReceptor: null,
      rolUsuario: null,
      hayChatAbierto: false,      
    };
  },
  async mounted() {
    const response2 = await axios.get("cuentas/usuario", {
      headers: {
        Authorization: localStorage.getItem("auth"),
      },
    });
    this.usuario = response2.data;
    this.rolUsuario = this.usuario.rol;
    //carga de conversaciones (chats laterales a la izquierda)
    await axios
      .get("mensaje/getConversaciones?emisor=" + this.usuario.usuId, {
        headers: {
          Authorization: localStorage.getItem("auth"),
        },
      })
      .then((response) => {
        this.conversaciones = response.data;
        console.log(this.conversaciones);
      })
      .catch((error) => {
        console.log(error);
      });
  },
  methods: {
    //Carga de mensajes de una conversacion seleccionada (ventana de chat a la derecha)
    async abrirChat(id) {
      this.hayChatAbierto = true;
      this.receptor = id;
      await axios
        .get(
          "mensaje/getConversacion?emisor=" +
            this.usuario.usuId +
            "&receptor=" +
            id,
          {
            headers: {
              Authorization: localStorage.getItem("auth"),
            },
          }
        )
        .then((response) => {
          this.chatActual = response.data.reverse();
          if (this.chatActual[0].emisor.usuId == this.usuario.usuId) {
            this.nombreReceptor =
              this.chatActual[0].receptor.nombre +
              " " +
              this.chatActual[0].receptor.apellidoPaterno;
          } else {
            this.nombreReceptor =
              this.chatActual[0].emisor.nombre +
              " " +
              this.chatActual[0].emisor.apellidoPaterno;
          }
        })
        .catch((error) => {
          console.log(error);
        });
      //Envía scroll al final de la ventana de chat
      var messageBody = document.querySelector("#messageBody");
      messageBody.scrollTop = messageBody.scrollHeight;
    },
    formatearFecha(fecha) {
      return moment(fecha).format("DD/MM/YYYY HH:mm:ss");
    },
    async enviarMensaje(id) {
      if (this.text != "") {
        this.receptor = id;
        await axios
          .post(
            "mensaje/nuevoMensaje?cuerpo=" +
              this.text +
              "&emisor=" +
              this.usuario.usuId +
              "&receptor=" +
              id,
            this.form,
            {
              headers: {
                Authorization: localStorage.getItem("auth"),
              },
            }
          )
          .then((response2) => {
            this.abrirChat(this.receptor);
            console.log(
              "numero emisor :" +
                this.usuario.usuId +
                "numero receptor" +
                id +
                response2
            );
          })
          .catch((error) => {
            console.log(error);
          });
      }
      this.text = "";

      await axios
        .get("mensaje/getConversaciones?emisor=" + this.usuario.usuId, {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((response) => {
          this.conversaciones = response.data;
          console.log(this.conversaciones);
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
  computed: {},
  components: { ModalApoderado, ModalDocente, Navbar, Footer },
};
</script>

<style scoped>
.scrollbar::-webkit-scrollbar {
  width: 15px;
  height: 20px;
}

.scrollbar::-webkit-scrollbar-track {
  border-radius: 100vh;
  background: white;
}

.scrollbar::-webkit-scrollbar-thumb {
  background: #a181e2;
  border-radius: 100vh;
  border: 3px solid white;
}

.scrollbar::-webkit-scrollbar-thumb:hover {
  background: #8565c5;
}
</style>
